//======================================================================
//
//	 incskies_001_8k.fx
//
//   swSkySphere.fxx[XɁAeNX`C
//
//   aokcub / http://aokcub.net/cg
//
//======================================================================
// swSkySphere.fx
//
//   Sky Dome with function to cancel camera movements.
//   All-sky spherical mapping, no alpha blend.
//   Please see "swGridSphere.png" to understand mapping system.
//
//   You may use, modify and redistribute it
//   freely for any purpose including commercial purpose.
//
//   Jړ̃LZ@\tXJCh[B
//   ʃ}bsOŁAAt@uhB
//   }bsOWn "swGridSphere.png" QƁB
//
//   ̃t@CёΉXt@CɊւẮA
//   p܂ߖŗpEρEĔzzB
//
//   By tagoshu <tagoshu@celestial-spells.com>
//     English:
//       http://www.celestial-spells.com/en/logs/software/mmd-soft/
//       https://twitter.com/tagoshu_en
//     Japanese:
//       http://www.celestial-spells.com/logs/software/mmd_soft/
//       http://www.nicovideo.jp/user/23028070
//       https://twitter.com/tagoshu
//======================================================================

//----------------------------------------------------------------------
//	Parameters
//----------------------------------------------------------------------

// Diffuse Color (fBt[YF)
//   float4(r, g, b, 1)
#define DIFFUSE_COLOR float4(1.0, 1.0, 1.0, 1)

// Sky Dome Texture (XJCh[EeNX`)
//   It will override the texture setting in the *.x file.
//   Xt@C̃eNX`w͖܂B
#define SKY_TEXTURE "../incskies_001_8k.png"

// Radius of sky dome (XJCh[a)
//   No need to change ({IɕύXsv)
#define STAR_DISTANCE 8000.0

//----------------------------------------------------------------------
//	Codes
//----------------------------------------------------------------------
float4x4 WorldViewProjMatrix : WORLDVIEWPROJECTION;

float4	 MaterialDiffuse	: DIFFUSE  < string Object = "Geometry"; >;
float3	 CameraPosition 	: POSITION	< string Object = "Camera"; >;
float2	 ScreenSize 		: VIEWPORTPIXELSIZE;

// XJCh[EeNX`
texture2D SkyTex <
	string ResourceName = SKY_TEXTURE;
>;
sampler SkyTexSampler = sampler_state {
	texture = <SkyTex>;
	ADDRESSU = WRAP;
	ADDRESSV = CLAMP; // <-- VȂ̂h~
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
	MIPFILTER = LINEAR;
};

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);

// o͍\
struct VS_OUTPUT {
	float4 Pos   : POSITION;  // <-- ˉeϊW
	float2 Tex   : TEXCOORD1; // <-- eNX`
};

//----------------------------------------------------------------------
// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float2 Tex : TEXCOORD0)
{
	VS_OUTPUT Out;

	// J_̃[hr[ˉeϊ
	//	 J̈ړLZA
	//	 _ɓV̒SɁB
	float4x4 mat = WorldViewProjMatrix;
	mat[3] = float4(0,0,0,1);

	Pos.xyz *= STAR_DISTANCE;
	Out.Pos = mul( Pos, mat );
	Out.Tex = Tex;

	return Out;
}

//----------------------------------------------------------------------
// sNZVF[_
float4 Basic_PS(VS_OUTPUT IN) : COLOR0
{
	// eNX`Kp
	//   Xt@C̃eNX`w͖B
	float4 Color = tex2D( SkyTexSampler, IN.Tex );
	Color *= DIFFUSE_COLOR;

	return Color;
}

//----------------------------------------------------------------------
// IuWFNg`peNjbNiANZTpj
technique RenderParticle < string Script = "Pass=DrawObject;"; >
{
	pass DrawObject {
		ZENABLE = TRUE;
		ZWRITEENABLE = FALSE;
		CULLMODE = NONE;

		// No Blend
		ALPHABLENDENABLE = FALSE;

		VertexShader = compile vs_2_0 Basic_VS();
		PixelShader  = compile ps_2_0 Basic_PS();
	}
}
//======================================================================
// EOF
//======================================================================
